// -*- Mode:C++ -*-
//Header:
//File: Hearnfo.cc
//Title: HearInfo
//Author: NODA, Itsuki
//Date: 2001/03/05
//

//ModifyHistory:
// 2001/03/05: Start to create this file
//EndModifyHistory:

#include "HearInfo.h"

namespace Soccer {

   //--------------------------------------------------
   // scan hear info

   Bool HearInfo::scan(SimpleSexp & s) {

      UInt len = s.length() ;

      if(len < 3) return False ;

      time.set(s.nth(1)->scanAsInt()) ;

      SimpleSexp * sendertype = s.nth(2) ;

      if        (sendertype->equal(SC_SENDERNAME_REFEREE)) { 
	 sender = Referee ; 
      } else if (sendertype->equal(SC_SENDERNAME_SELF)) { 
	 sender = Self ; 
      } else if (sendertype->equal(SC_SENDERNAME_OLCOACHL)) { 
	 sender = OnlineCoachL;
      } else if (sendertype->equal(SC_SENDERNAME_OLCOACHR)) { 
	 sender = OnlineCoachR;
      } else { 
	 sender = Player ; 
	 aux.direction = s.nth(2)->scanAsFlt() ;
      } 

      message().copy(s.nth(3)->str) ;

      if(sender == Referee) {
	 aux.pmode = scanAsScWord(message()) ;
	 if(isNull(aux.pmode)) {
	    ITK_WRN("unknown playmode:" << message()) ;
	    aux.pmode = &(SC_WORD(_Unknown)) ;
	 }
      }

      return True ;
   } 

}












